import * as mc from "@minecraft/server";

mc.world.beforeEvents.worldInitialize.subscribe(event => {
	const itemComponentRegistry = event.itemComponentRegistry;

	itemComponentRegistry.registerCustomComponent("wesl3y:staff_shadow",{onUse: arg => {staff_shadow(arg.source);}});
});

async function staff_shadow(player) {
  player.runCommandAsync("playanimation @s animation.staff_shadow wesl3y");
  player.runCommandAsync("playsound summon @a ~~~ 1.5");
  staff_shadow2(player, "wesl3y:projetil_tamed", [-3, 0, 0], "skeleton1");
  staff_shadow2(player, "wesl3y:projetil_tamed", [3, 0, 0], "skeleton2");
  staff_shadow2(player, "wesl3y:projetil_tamed", [0, 0, -3], "skeleton3");
  staff_shadow2(player, "wesl3y:projetil_tamed", [0, 0, 3], "skeleton4");
}

function staff_shadow2(player, powerId, offset, eventId) {
  const location = offsetL(player.getHeadLocation(),player.getRotation(),offset);
  common(location);
  function common(location) {
    const power = player.dimension.spawnEntity(powerId,location);
    if(eventId != null){
      power.triggerEvent(eventId);
    }
    const projectileComp = power.getComponent("projectile");
    projectileComp.owner = player;
    //projectileComp.shoot(player.getViewDirection());
  }
}

export function offsetL(location,rotation,offset){
    function round100000(number) {
        return Math.round(100000*number)/100000;
    }
    const x_entityRotationY = (rotation.y + 90) * (Math.PI/180);
    const x_positionX = -round100000(Math.sin(x_entityRotationY));
    const x_positionZ = round100000(Math.cos(x_entityRotationY));
    
    const z_entityRotationY = rotation.y * (Math.PI/180);
    const z_entityRotationX = rotation.x * (Math.PI/180);
    const z_positionX = -round100000(Math.sin(z_entityRotationY)*Math.cos(z_entityRotationX));
    const z_positionZ = round100000(Math.cos(z_entityRotationY)*Math.cos(z_entityRotationX));
    const z_positionY = -round100000(Math.sin(z_entityRotationX));
    
    const y_entityRotationY = rotation.y * (Math.PI/180);
    const y_entityRotationX = rotation.x * (Math.PI/180);
    const y_positionX = -round100000(Math.sin(y_entityRotationY)*Math.sin(y_entityRotationX));
    const y_positionZ = round100000(Math.cos(y_entityRotationY)*Math.sin(y_entityRotationX));
    const y_positionY = round100000(Math.cos(y_entityRotationX));

    return {
        x:location.x + x_positionX*offset[0] + y_positionX*offset[1] + z_positionX*offset[2],
        y:location.y + z_positionY*offset[2] + y_positionY*offset[1],
        z:location.z + x_positionZ*offset[0] + y_positionZ*offset[1] + z_positionZ*offset[2]
    }
}